package com.sa.ibiz.demo.demoapp.controller.demo.vo;

import java.sql.Timestamp;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonProperty.Access;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotEmpty;
import javax.validation.constraints.NotNull;
import lombok.Data;
import org.springframework.util.StringUtils;
import com.sa.ibiz.demo.demo.domain.UserRoleDataAction;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import java.util.Map;
import java.util.Date;
import org.springframework.cglib.beans.BeanCopier;
import javax.validation.constraints.Size;
import java.util.UUID;
import org.springframework.cglib.beans.BeanCopier;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.sa.ibiz.demo.ibizutil.security.AuthenticationUser;
import java.math.BigInteger;
import com.alibaba.fastjson.JSONObject;

@Data
@JsonIgnoreProperties(ignoreUnknown = true)
public class UserRoleDataAction_EditForm_Main{

    @JsonProperty(access=Access.WRITE_ONLY)
    private Map<String,String> srfparentdata;
    @JsonIgnore
    private Timestamp updatedate;
    @JsonProperty(access=Access.WRITE_ONLY)
    private String srforikey;
    @JsonIgnore
    private String userroledataactionid;
    @JsonIgnore
    private String userroledataactionname;
    @JsonIgnore
    private String srftempmode;
    @JsonProperty
    private String srfuf;
    @JsonProperty
    private String srfdeid;
    @JsonProperty(access=Access.WRITE_ONLY)
    private String srfsourcekey;
    @JsonIgnore
    private String userroledataid;
    @JsonIgnore
    private Integer isallow;

    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JsonProperty(value = "srfupdatedate")
    public Timestamp getSrfupdatedate(){
        return updatedate;
    }
    @JsonProperty(value = "srfupdatedate")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    public void setSrfupdatedate(Timestamp updatedate){
        this.updatedate = updatedate;
    }

    @JsonProperty(value = "srforikey")
    public String getSrforikey(){
        return srforikey;
    }
    @JsonProperty(value = "srforikey")
    public void setSrforikey(String srforikey){
        this.srforikey = srforikey;
    }

    @Size(min = 0, max = 100, message = "[用户角色数据操作标识]长度必须在[100]以内!")
    @JsonProperty(value = "srfkey")
    public String getSrfkey(){
        return userroledataactionid;
    }
    @JsonProperty(value = "srfkey")
    public void setSrfkey(String userroledataactionid){
        this.userroledataactionid = userroledataactionid;
    }

    @Size(min = 0, max = 200, message = "[操作名称]长度必须在[200]以内!")
    @JsonProperty(value = "srfmajortext")
    public String getSrfmajortext(){
        return userroledataactionname;
    }

    @JsonProperty(value = "srftempmode")
    public String getSrftempmode(){
        return srftempmode;
    }
    @JsonProperty(value = "srftempmode")
    public void setSrftempmode(String srftempmode){
        this.srftempmode = srftempmode;
    }

    @JsonProperty(value = "srfdeid")
    public String getSrfdeid(){
        return srfdeid;
    }
    @JsonProperty(value = "srfdeid")
    public void setSrfdeid(String srfdeid){
        this.srfdeid = srfdeid;
    }

    @Size(min = 0, max = 100, message = "[用户角色数据操作_用户角色数据]长度必须在[100]以内!")
    @JsonProperty(value = "userroledataid")
    public String getUserroledataid(){
        //输出获取外键值方法-用于通过parentdata关系填充外键值id
        if(StringUtils.isEmpty(userroledataid) && this.getSrfparentdata() != null)
        {
            if(this.getSrfparentdata().containsKey("srfparentmode")&& this.getSrfparentdata().get("srfparentmode").equals("DER1N_USERROLEDATAACTION_USERROLEDATA_USERROLEDATAID"))
                this.userroledataid=this.getSrfparentdata().get("srfparentkey");
        }
        return userroledataid;
    }
    @JsonProperty(value = "userroledataid")
    public void setUserroledataid(String userroledataid){
        this.userroledataid = userroledataid;
    }

    @NotBlank(message = "[操作名称]不允许为空!")
    @Size(min = 0, max = 200, message = "[操作名称]长度必须在[200]以内!")
    @JsonProperty(value = "userroledataactionname")
    public String getUserroledataactionname(){
        return userroledataactionname;
    }
    @JsonProperty(value = "userroledataactionname")
    public void setUserroledataactionname(String userroledataactionname){
        this.userroledataactionname = userroledataactionname;
    }

    @NotNull(message = "[允许]不允许为空!")
    @JsonProperty(value = "isallow")
    public Integer getIsallow(){
        return isallow;
    }
    @JsonProperty(value = "isallow")
    public void setIsallow(Integer isallow){
        this.isallow = isallow;
    }

    @Size(min = 0, max = 100, message = "[用户角色数据操作标识]长度必须在[100]以内!")
    @JsonProperty(value = "userroledataactionid")
    public String getUserroledataactionid(){
        return userroledataactionid;
    }
    @JsonProperty(value = "userroledataactionid")
    public void setUserroledataactionid(String userroledataactionid){
        this.userroledataactionid = userroledataactionid;
    }

    public  void fromUserRoleDataAction(UserRoleDataAction sourceEntity)  {
        this.fromUserRoleDataAction(sourceEntity,true);
    }

     /**
	 * do转换为vo
	 * @param sourceEntity do数据对象
	 * @return
	 */
    public  void fromUserRoleDataAction(UserRoleDataAction sourceEntity,boolean reset)  {
      BeanCopier copier=BeanCopier.create(UserRoleDataAction.class, UserRoleDataAction_EditForm_Main.class, false);
      copier.copy(sourceEntity,this,  null);
      this.toString();
	}

    /**
	 * vo转换为do
	 * @param
	 * @return
	 */
    public  UserRoleDataAction toUserRoleDataAction()  {
        UserRoleDataAction targetEntity =new UserRoleDataAction();
        BeanCopier copier=BeanCopier.create(UserRoleDataAction_EditForm_Main.class, UserRoleDataAction.class, false);
        copier.copy(this, targetEntity, null);
        return targetEntity;
	}

     /**
	 * 新建
	 * @param
	 * @return
	 */
    private boolean isCreate()
    {
    	if((StringUtils.isEmpty(this.srfuf))||this.srfuf.equals("0"))
	    	return true;
    	else
    	    return false;
    }
     /**
	 * 更新
	 * @param
	 * @return
	 */
    private boolean isUpdate()
    {
    	if((!StringUtils.isEmpty(this.srfuf))&&this.srfuf.equals("1"))
	    	return true;
    	else
    	    return false;
    }

}
